**Latest Tag Release**
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-RV-NEPHELE-HDAR/wiki/hdarapi-coverage-latesttag.svg)
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-RV-NEPHELE-HDAR/wiki/hdarapi-version-latesttag.svg)

**Develop**
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-RV-NEPHELE-HDAR/wiki/hdarapi-coverage-develop.svg)
![Not found](https://github.gsissc.myatos.net/GLB-BDS-ETSN-SECURITY/xNF-RV-NEPHELE-HDAR/wiki/hdarapi-version-develop.svg)


## Description

The REST API currently focuses on: 
1. Custom functionalities for ease the use of the Nephele meta-orchestration framework
2. Service catalogue and discovery
3. Provides the API to interact with the OCI Registry programatically as required by the project's dashboard. 
4. It provides additional functionalitites for the development of HDAGs

Available **https://hdarapi.nephele-hdar.netmode.ece.ntua.gr/swagger/index.html**

## Getting Started

- endpoints: Provides the OpenAPI endpoints using Swaggo comments. Automated docs are under the openapi folder.

### Prerequisites

Full configuration via ENV Vars:

- Check $PWD/install/.env-test for local deployment and move it to $PWD/.env

#### Software

Project built using Golang 1.22 and requires to have an OCI Registry installed and accessible -> **registry.nephele-hdar.netmode.ece.ntua.gr**.


#### Hardware

No major requirements found. 1vCPU, 1GiB RAM

### Installation

Project developed using WSL Golang installation

1. Go auto formatting and linting. Execute before pushing to origin. It is automated in CI pipeline and will fail if not ok

```bash
go fmt $(go list ./... | grep -v /vendor/)
go vet $(go list ./... | grep -v /vendor/)
```

2. Update te swagger docs (alerts in CI pipeline if version in pkg/endpoints/openapi/swagger.yaml is not updated)

```bash
go get github.com/swaggo/swag/cmd/swag@latest
go get github.com/swaggo/http-swagger
go install github.com/swaggo/swag/cmd/swag@latest
go install github.com/swaggo/http-swagger
PATH=$(go env GOPATH)/bin:$PATH
swag init --output pkg/endpoints/openapi --parseDependency
go mod tidy
```

3. Make sure tests pass

```bash
go test $(go list ./... | grep -v /vendor/) -v
```

4. Build

A) Manually

```bash
GOOS=linux GARCH=amd64 CGO_ENABLED=0 go build -v -a -installsuffix cgo -o hdarapi . 
# adapt env vars
cp install/.env-tests .env
export $(grep -v '^#' .env | xargs)
./hdarapi
```

B) Create docker image locally or pull the one generated by the CICD pipeline

```bash
# Needs the full repo context
cd ../../
docker build -t registry.atosresearch.eu:18498/hdarapi:develop --network host -f components/hdar-api/install/dockerfile . 
cd components/hdar-api
```

## Usage

The REST API service which is exposed via a Swagger OpenAPI
- Open in **http://ServiceIP:ServicePort/swagger/index.html**
- [Swagger YAML](./pkg/endpoints/openapi/swagger.yaml).

Localy
```bash
docker run -p 8080:8080 --env-file install/.env-tests --entrypoint ./hdarapi registry.atosresearch.eu:18498/hdarapi:latest
```

## Contribution

Tech:

- Guillermo Gomez guillermo.gomezchavez@eviden.com

Asset Owner:

- Sonia Castro sonia.castro@eviden.com

A Gitflow methodology is implemented within this repo. Proceed as follows:

1. Open an Issue, label appropriately and assign to the next planned release.
2. Pull the latest develop and branch off of it with a branch or PR created from GitHub as draft.
3. Commit and push frequently.
4. When ready, set PR as ready, tag team and wait for approval.

## License

ATOS and Eviden Copyright applies. Apache License

```text
/*
 * Copyright 20XX-20XX, Atos Spain S.A.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the copyright holder nor the names of its
 *     contributors may be used to endorse or promote products derived from
 *     this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
```
